<?php
   session_start();
?>
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<meta name="description" content="Datenbanken und SQL: berblick, Session">
<meta name="author" content="Edwin Schicker">
<title>Datenbanken und SQL: Sessioneinsprungseite, Teil 2</title>
</head>

<body text="#000000" bgcolor="#FFFFEF" link="#FF0000" alink="#FF0000" vlink="#FF0000">
<center><h1>Datenbanken und SQL</h1></center>
<center><h3>Edwin Schicker</h3></center>
<p>Dies ist die Datei <i>index.php</i> im Sessionteil. Von hier aus wird zu den einzelnen Themen verzweigt. </p>

<?php
// Ueberpruefen, ob die notwendigen Einlogdaten exisitieren, entweder als Post- oder als Sessionvariable:
if ( (!isset($_POST['Hersteller']) and !isset($_SESSION['Hersteller'])) or 
     ((!isset($_POST['Datenbank']) or !isset($_POST['Server'])) and !isset($_SESSION['Parameter1'])) or 
     (!isset($_POST['Kennung']) and !isset($_SESSION['Kennung'])) or 
     (!isset($_POST['Passwort']) and !isset($_SESSION['Passwort'])) )
   echo "<p>Bitte loggen Sie sich erst in die Datenbank ein</p>";
else
{
   if (!isset($_SESSION['Hersteller']))       // Session-Variablen noch nicht gesetzt!
   {
      // Sessionvariablen aus Postvariablen bernehmen:
      $_SESSION['Hersteller'] = $_POST['Hersteller'];
      $_SESSION['Kennung']    = $_POST['Kennung'];
      $_SESSION['Passwort']   = $_POST['Passwort'];
      
      // Neue Sessionvariable Parameter1 aus Datenbank und Server erzeugen:
      switch ($_SESSION['Hersteller'])    // Einloggen in die Datenbank je nach Hersteller
      {
        case "Oracle":     $_SESSION['Parameter1'] = "oci:dbname=$_POST[Datenbank]";         
                           break;
        case "SQLServer":  $_SESSION['Parameter1'] = "sqlsrv:Server=$_POST[Server];Database=$_POST[Datenbank]";  
                           break;
        case "MySQL":      $_SESSION['Parameter1'] = "mysql:host=$_POST[Server];dbname=$_POST[Datenbank]";
                           break;
      }
   }

?>
   <p>Bitte whlen Sie eines der folgenden Themen aus. Die Realisierung ist 
     bewusst einfach gehalten. Klicken Sie den gewnschten Button:</p>

   <table cellpadding="10">
   <tr>
    <td align="right"> <form action="start.php">
                       <input type="Submit" value="Erster DB-Zugriff auf die Bike-DB">
                      </form>
    </td>
    <td valign="top"> Die Datei <i>start.php</i> wird aufgerufen
    </td>
   </tr>
   <tr>
    <td align="right"> <form action="mitarbeiter.php">
                       <input type="Submit" value="Ausgabe der Relation Personal"/>
                      </form>
    </td>
    <td valign="top"> Die Datei <i>mitarbeiter.php</i> wird aufgerufen
    </td>
   </tr>
   <tr>
    <td align="right"> <form action="auswahl.php">
                       <input type="Submit" value="DB-Zugriff mit Select-Auswahl"/>
                      </form>
    </td>
    <td valign="top"> Die Datei <i>auswahl.php</i> wird aufgerufen </td>
   </tr>
   <tr>
    <td align="right"> <form action="select.php">
                       <input type="Submit" value="Beliebigen SQL-Befehl ausfhren"/>
                     </form>
    </td>
    <td valign="top"> Die Datei <i>select.php</i> wird aufgerufen
    </td>
   </tr>
   <tr>
    <td align="right"> <form action="transaktion1.php">
                       <input type="Submit" value="Schreib-Transaktion ausfhren"/>
                     </form>
    </td>
    <td valign="top"> Die Datei <i>transaktion1.php</i> wird aufgerufen
    </td>
   </tr>
   <tr>
    <td align="right"> <form action="blob_ein1.php">
                       <input type="Submit" value="Bild in DB speichern"/>
                     </form>
    </td>
    <td valign="top"> Die Datei <i>blob_ein1.php</i> wird aufgerufen
    </td>
   </tr>
   <tr>
    <td align="right"> <form action="mitarbeiterblob.php">
                       <input type="Submit" value="Bilder aus DB auslesen"/>
                     </form>
    </td>
    <td valign="top"> Die Datei <i>mitarbeiterblob.php</i> wird aufgerufen
    </td>
   </tr>
   <tr>
    <td align="right"> <form action="reset.php">
                       <input type="Submit" value="Session zurcksetzen"/>
                     </form>
    </td>
    <td valign="top"> Die Datei <i>reset.php</i> wird aufgerufen </td>
   </tr>
   </table>

<?php
}  //endif
?>

<p><b>Links zu bungsaufgaben in Kapitel 6:</b></p>
<p>
  <a href="ueb_kap6_3.php">bung 3</a> <br/>
  <a href="ueb_kap6_4.php">bung 4</a> <br/>
  <a href="ueb_kap6_5.php">bung 5</a> <br/>
  <a href="ueb_kap6_6.php">bung 6</a> <br/>
  <a href="ueb_kap6_7.php">bung 7</a> <br/>
  <a href="ueb_kap6_8.php">bung 8</a> <br/> </p>

<hr noshade size="1">
<p><center><a href="reset.php">Beenden der Session und neues Einloggen</a></center></p>
</body>
</html>